<template>
  <q-page class="flex flex-top q-pa-xl">
    <q-form
      v-on:submit="onSubmit"
      v-on:reset="onReset"
      class="q-gutter-md"
    >
      <q-input
        filled
        v-model="fullName"
        label="Nombre Completo *"
        hint="Nombre y Apellido"
        lazy-rules
        v-bind:rules="[ val => val && val.length > 0 || 'Ingrese su nombre, por favor.']"
      />

      <q-input
        filled
        type="email"
        v-model="email"
        label="Correo Electrónico *"
        hint="Su email de conctacto"
        lazy-rules
        v-bind:rules="[ val => val && val.length > 0 || 'Ingrese su correo, por favor.']"
      />

      <q-input
        filled
        type="email"
        v-model="confirmEmail"
        label="Confirme su correo Electrónico *"
        hint="Debe coincidir con su email de conctacto"
        lazy-rules
        v-bind:rules="[ val => val === email && val.length > 0 || 'Ingrese su correo, por favor.']"
      />

      <q-input
        v-model="password"
        label="Contraseña *"
        filled
        v-bind:type="isPwd ? 'password' : 'text'"
        hint="Mínimo 6 caracteres"
        lazy-rules
        v-bind:rules="[ val => val && val.length > 6 || 'Ingrese una contraseña segura, por favor.']"
      >
        <template v-slot:append>
          <q-icon
            v-bind:name="isPwd ? 'visibility_off' : 'visibility'"
            class="cursor-pointer"
            v-on:click="isPwd = !isPwd"
          />
        </template>
      </q-input>

      <q-input
        v-model="confirmPassword"
        label="Confirme Contraseña *"
        filled
        v-bind:type="isPwd ? 'password' : 'text'"
        hint="Debe coincidir con su contraseña"
        lazy-rules
        v-bind:rules="[ val => val === password || 'No coincide con su contraseña']"
      >
        <template v-slot:append>
          <q-icon
            v-bind:name="isPwd ? 'visibility_off' : 'visibility'"
            class="cursor-pointer"
            v-on:click="isPwd = !isPwd"
          />
        </template>
      </q-input>

      <q-toggle v-model="terms" label="Estoy de acuerdo con los terminos y condiciones para el registro de mi cuenta." />

      <div>
        <q-btn label="Registrar" type="submit" color="primary"/>
        <q-btn label="Cancelar" type="reset" color="primary" flat class="q-ml-sm" />
      </div>
    </q-form>

  </q-page>
</template>

<script>
export default {
  name: 'Registration',
  data () {
    return {
      fullName: null,
      email: null,
      password: null,
      isPwd: true,
      confirmPassword: null,
      confirmEmail: null,
      terms: false
    }
  },
  methods: {
    onSubmit () {
      if (this.terms !== true) {
        this.$q.notify({
          color: 'negative',
          textColor: 'white',
          icon: 'warning',
          message: 'Necesita aceptar terminos y condiciones del sistema.'
        })
      } else {
        this.$connection.post('signup', {
          fullName: this.fullName,
          email: this.email,
          password: this.password,
          confirmPassword: this.confirmPassword,
          confirmEmail: this.confirmEmail,
          terms: this.terms
        })
          .then(() => {
            this.$q.notify({
              color: 'positive',
              textColor: 'white',
              icon: 'cloud_done',
              message: 'Ingresado exitosamente al sistema.'
            })
            this.$store.dispatch('auth/logIn',
              { email: this.email, password: this.password })
              .then(() => this.$router.go('/home'))
          })
          .catch(() => {
            this.$q.notify({
              color: 'negative',
              textColor: 'white',
              icon: 'cloud_off',
              message: 'Error al crear su cuenta. Por favor, vuelvalo a intentar más tarde.'
            })
          })
      }
    },
    onReset () {
      this.$router.go(-1)
    }
  }
}
</script>
